' Sparrow/T13 Solar-Logger (Zenit bei 7,5ost = 13.30 Uhr Sommerzeit)
'
' Summierung bis zu 15 Stunden (6-21Uhr), 439.5 messungen/h = 1hconst
' Versuche zeigen, das schon nach 400 Messungen 1h um ist -> 1hconst=400, ggf. anpassen
'
' bei jeder Messung blitzt RED schwach
' mit S1 (8s festhalten) wird das EEPROM gelscht, wenn RED schwach leuchtet
' gemessen wird an B.4=Ad2
'
' U = I*Rs
' ad = U*1023/Uref = I*Rs*1023/1100mV = I*Rs*0,93
' mit 1mA*1h -> 1h*1mA *Rs*0,93 = 1hconst*1mA *Rs*0,93 = mAh
' Ifconst = 1hconst*Rs*0.93
'
' Imax = Uref/Rs
' in Mah stehen die mAh (Word) berechnet zur Verfgung
' die Nachkommastelle kann berechnet werden: Mal / ifconst
' die erste EEPROM-Zelle kann zufllige Werte annehmen! und wird nicht genutzt
'-------------------------------------------------------------------------------
$regfile = "attiny13.dat"
$crystal = 1200000                                          '$prog &HFF , &H22 , &HFF , &H00 preserve EEPROM
$hwstack = 8                                                '32
$swstack = 8                                                '8
$framesize = 8                                              '16
$programmer = 19                                            'UsbAsp
Stop Ac :

U0 Alias Getadc(0)
Ddrb.0 = 0 : S1 Alias Pinb.0 : S1p Alias Portb.0 : S1p = 1  'pullup S1
Ddrb.3 = 0 : Red Alias Portb.3
Ddrb.4 = 0 : U2 Alias Getadc(2)

Config Watchdog = 8192 : Start Watchdog : Reset Watchdog
Config Adc = Single , Prescaler = Auto , Reference = Internal

Const 1hconst = 400                                         '3600s/8.192s=439.45
Const Ifconst = 3720                                        'Rs= 10R, Imax= 110mA
'Const Ifconst = 4464                                        'Rs= 12R, Imax=  91mA

Dim Mal As Word                                             '
Dim Mah As Word                                             '=1*mAh
Dim Messung As Word                                         'anzahl
Dim Stunde As Byte                                          'stunde
Dim Zeiger As Byte
Dim Zeigerh As Byte
Red = 1                                                     'test
'-------------------------------------------------------------------------------
Readeeprom Stunde , 1                                       '1 bis 15
Readeeprom Messung , 2                                      'anzahl

If Messung > 1hconst Then : Messung = 0 : Stunde = Stunde + 1 : End If       'next h

If Stunde > 15 Then : Messung = 0 : Stunde = 1 : End If     'berlauf

If S1 = 0 Then :                                            'EE lschen
   Messung = 0 :
   For Stunde = 1 To 63 : Writeeeprom Messung , Stunde : Next
   Stunde = 1 : Do : Loop Until S1 = 1 : End If             'S1 ?

Zeiger = Stunde * 4
Readeeprom Mal , Zeiger                                     'x*uAh, mAh=Mal/Ifconst
If Messung = 0 Then Mal = 0
If Mal = 65535 Then Mal = 0                                 'FFFF

Zeigerh = Zeiger + 2
Readeeprom Mah , Zeigerh                                    'mAh
If Messung = 0 Then Mah = 0
If Mah = 65535 Then Mal = 0                                 'FFFF

Mal = Mal + U2                                              'summierung
If Mal > Ifconst Then
   Mal = Mal - Ifconst
   Mah = Mah + 1 : End If

Messung = Messung + 1
Writeeeprom Stunde , 1                                      'EE 1
Writeeeprom Messung , 2                                     'EE 3+2
Writeeeprom Mal , Zeiger                                    'EE 5+4 ...
Writeeeprom Mah , Zeigerh                                   'EE 7+6 ...

Red = 0                                                     'test
Powerdown :
Nop                                                         'warte auf WD-Reset
'-------------------------------------------------------------------------------
End
Data "____S o l a r - L o g g e r ____"
'end program